
//#include <iostream>
//#include <fstream>
using namespace std ;

#include <iostream>
#include <cmath>

//#include <iostream>
//#include <cmath>

#include <qapplication.h>
#include <qmenubar.h>
#include <qmessagebox.h>
#include <qpainter.h>
#include <qpopupmenu.h>
#include <qpixmap.h>
#include <qwidget.h>
#include <qstring.h>
#include <qfiledialog.h>
#include <qcolor.h>
#include <qlabel.h>
#include <qslider.h>
#include <qstatusbar.h>

#include <qtabwidget.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qtextedit.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qframe.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qdialog.h>


#include "constants.h"
#include "fenetrePrincipale.h"
#include "conteneur.h"
#include "planche.h"
#include "repartition.h"
#include "qdoubleslider.h"
#include "preferences.h"

fenetrePrincipale :: fenetrePrincipale()
{
 long i ;

 setCaption( "fracat-0.0.0" ) ;
 isMatrixLong = true ;
 drawMatrixWithRepartition = false ;
 whatSthat = TYPE_ID_MANDELBROT ;
 _parameters = NULL ;
 maxii = 150 ;
 minii = 0 ;
 maxid = 150.0 ;
 minid = 0.0 ;
 _parameters = new QString[5] ;
 for(i=0;i<SIZE_IMAGE_REPARTITION_X;i++) repartitionZoom[i] = 0 ;
 repartitionZoom[1] = 47272 ;
 repartitionZoom[3] = 78183 ;
 repartitionZoom[5] = 46110 ;
 repartitionZoom[6] = 18927 ;
 repartitionZoom[8] = 10528 ;
 repartitionZoom[10] = 6065 ;
 repartitionZoom[12] = 4192 ;
 repartitionZoom[13] = 2843 ;
 repartitionZoom[15] = 2172 ;
 repartitionZoom[17] = 1586 ;
 repartitionZoom[18] = 1343 ;
 repartitionZoom[20] = 967 ;
 repartitionZoom[22] = 873 ;
 repartitionZoom[24] = 683 ;
 repartitionZoom[25] = 556 ;
 repartitionZoom[27] = 549 ;
 repartitionZoom[29] = 446 ;
 repartitionZoom[30] = 406 ;
 repartitionZoom[32] = 351 ;


    setCentralWidget( new QWidget( this, "qt_central_widget" ) );
    //tabWidget2 = new QTabWidget( this, "tabWidget2" );
    tabWidget2 = new QTabWidget( centralWidget(), "tabWidget2" );
    tabWidget2->setGeometry( QRect( 10, 0, 280, 330 ) );

    _repartition = new repartition( tabWidget2, "_repartition",0 );
    _repartition->drawRepartition(repartitionZoom) ;

    lineEdit3 = new QLineEdit( _repartition, "lineEdit3" );
    lineEdit3->setGeometry( QRect( 9, 113, 70, 24 ) );

    lineEdit4 = new QLineEdit( _repartition, "lineEdit4" );
    lineEdit4->setGeometry( QRect( 199, 113, 70, 24 ) );

    pushButton1 = new QPushButton( _repartition, "pushButton1" );
    pushButton1->setGeometry( QRect( 129, 113, 20, 20 ) );

    buttonGroup2 = new QButtonGroup( _repartition, "buttonGroup2" );
    buttonGroup2->setGeometry( QRect( 10, 210, 100, 80 ) );

    RadioButton4 = new QRadioButton( buttonGroup2, "RadioButton4" );
    RadioButton4->setGeometry( QRect( 10, 50, 60, 22 ) );

    RadioButton2 = new QRadioButton( buttonGroup2, "RadioButton2" );
    RadioButton2->setGeometry( QRect( 10, 10, 80, 20 ) );

    RadioButton3 = new QRadioButton( buttonGroup2, "RadioButton3" );
    RadioButton3->setGeometry( QRect( 10, 30, 70, 22 ) );

    checkBox5 = new QCheckBox( _repartition, "checkBox5" );
    checkBox5->setGeometry( QRect( 120, 220, 93, 22 ) );
    tabWidget2->insertTab( _repartition, QString("") );

    textLabel1 = new QLabel( _repartition, "textLabel1" );
    textLabel1->setGeometry( QRect( 120, 250, 45, 20 ) );

    slider1 = new QSlider( 0,100,5,0,QSlider::Horizontal,_repartition, "slider1" );
    slider1->setGeometry( QRect( 170, 250, 100, 20 ) );

    tab_2 = new QWidget( tabWidget2, "tab_2" );

    textLabel3 = new QLabel( tab_2, "textLabel3" );
    textLabel3->setGeometry( QRect( 9, 33, 40, 20 ) );

    lineEdit5 = new QLineEdit( tab_2, "lineEdit5" );
    lineEdit5->setGeometry( QRect( 59, 23, 160, 24 ) );

    lineEdit6 = new QLineEdit( tab_2, "lineEdit6" );
    lineEdit6->setGeometry( QRect( 59, 53, 160, 24 ) );

    lineEdit7 = new QLineEdit( tab_2, "lineEdit7" );
    lineEdit7->setGeometry( QRect( 59, 83, 160, 24 ) );

    lineEdit8 = new QLineEdit( tab_2, "lineEdit8" );
    lineEdit8->setGeometry( QRect( 59, 113, 160, 24 ) );

    textLabel4 = new QLabel( tab_2, "textLabel4" );
    textLabel4->setGeometry( QRect( 9, 63, 44, 20 ) );

    textLabel5 = new QLabel( tab_2, "textLabel5" );
    textLabel5->setGeometry( QRect( 9, 93, 40, 20 ) );

    textLabel6 = new QLabel( tab_2, "textLabel6" );
    textLabel6->setGeometry( QRect( 9, 123, 44, 20 ) );
    tabWidget2->insertTab( tab_2, QString("") );

    frame5 = new QFrame( centralWidget(), "frame5" );
    frame5->setGeometry( QRect( 10, 340, 280, 110 ) );
    frame5->setFrameShape( QFrame::StyledPanel );
    frame5->setFrameShadow( QFrame::Raised );

    /////   widgets pour les paramtres des fractales
    textLabel_P1 = new QLabel( frame5, "textLabel_P1" );
    textLabel_P1->setGeometry( QRect( 10, 20, 64, 20 ) );
    textLabel_P1->setText(  "iterations"  );

    lineEdit_P1 = new QLineEdit( frame5, "lineEdit_P1" );
    lineEdit_P1->setGeometry( QRect( 80, 10, 100, 24 ) );
    lineEdit_P1->setText("150") ;
    /// fin pour les widgets pour les paramtres des fractales


    _dsRepartition = new QDoubleSlider(0,SIZE_IMAGE_REPARTITION_X-1,
    				       0,SIZE_IMAGE_REPARTITION_X-1,
				       _repartition,"_dsRepartition",0) ;
    _dsRepartition->setGeometry( QRect( 1, 143, 275, 24 ) );
    _dsPalette = new QDoubleSlider(0,SIZE_IMAGE_REPARTITION_X-1,
    				   0,SIZE_IMAGE_REPARTITION_X-1,
				   _repartition,"_dsPalette",0) ;
    _dsPalette->setGeometry( QRect( 1, 173, 275, 24 ) );

    lineEdit3->setText(  "0"  );
    lineEdit4->setText(  "149"  );
    lineEdit5->setText(  "-2.5"  );
    lineEdit6->setText(  "1.5"  );
    lineEdit7->setText(  "-1.5"  );
    lineEdit8->setText(  "1.5"  );
    pushButton1->setText(  "pushButton1"  );
    buttonGroup2->setTitle( QString::null );
    RadioButton4->setText(  "scie"  );
    RadioButton2->setText(  "satured"  );
    RadioButton2->setChecked(true) ;
    RadioButton3->setText(  "modulo"  );
    checkBox5->setText(  "inversed"  );
    tabWidget2->changeTab( _repartition,  "Color"  );
    textLabel1->setText( "Rotate"  );
    //textLabel1->setText( "Delay"  );
    textLabel3->setText(  "x min"  );
    textLabel4->setText(  "x max" );
    textLabel5->setText(  "y min"  );
    textLabel6->setText(  "y max"  );
    tabWidget2->changeTab( tab_2,  "Frame" );


 resize( QSize(300,504) ) ;

 // Cration des menus.
 _filemenu = new QPopupMenu(this) ;
 _filemenu->insertItem("Save Image",this,SLOT(slotSaveImage()),0,1 ) ;
 _filemenu->insertItem("Load Palette",this,SLOT(slotLoadPalette()),0,2 ) ;
 _filemenu->insertItem("Load Matrix",this,SLOT(slotNeRienFaire()),0,3 ) ;
 _filemenu->insertItem("Save Matrix",this,SLOT(slotNeRienFaire()),0,4 ) ;
 _filemenu->insertItem("Preferences",this,SLOT(slotPreferences()),0,5 ) ;
 _filemenu->insertItem("&Quit",qApp,SLOT(quit()),0,6 ) ;
 //_filemenu->setItemEnabled(1,false) ;
 //_filemenu->setItemEnabled(2,false) ;
 _filemenu->setItemEnabled(3,false) ;
 _filemenu->setItemEnabled(4,false) ;


 _typemenu = new QPopupMenu(this) ;
 //_typemenu->setCheckable(true) ;
 _typemenu->insertItem( "Mandelbrot" , TYPE_ID_MANDELBROT ) ;
 _typemenu->insertItem( "Julia" , TYPE_ID_JULIA ) ;
 _typemenu->setItemEnabled(TYPE_ID_JULIA ,false) ;

 _sizemenu = new QPopupMenu(this) ;
 //_sizemenu->setCheckable(true) ;
 _sizemenu->insertItem( "128" , SIZE_ID_128 ) ;
 _sizemenu->insertItem( "256" , SIZE_ID_256 ) ;
 _sizemenu->insertItem( "512" , SIZE_ID_512 ) ;
 _sizemenu->insertItem( "1024" , SIZE_ID_1024 ) ;
 _sizemenu->insertItem( "2048" , SIZE_ID_2048 ) ;
 _sizemenu->insertItem( "4096" , SIZE_ID_4096 ) ;
 _sizemenu->insertItem( "8196" , SIZE_ID_8192 ) ;
 _sizemenu->insertItem( "16384" , SIZE_ID_16384 ) ;
 _sizemenu->insertItem( "32768" , SIZE_ID_32768 ) ;
 _sizemenu->insertItem( "65536" , SIZE_ID_65536 ) ;
 //_sizemenu->setItemEnabled(SIZE_ID_128,false) ;
 //_sizemenu->setItemEnabled(SIZE_ID_256,false) ;
 //_sizemenu->setItemEnabled(SIZE_ID_1024,false) ;
 //_sizemenu->setItemEnabled(SIZE_ID_2048,false) ;
 _sizemenu->setItemEnabled(SIZE_ID_4096,false) ;
 _sizemenu->setItemEnabled(SIZE_ID_8192,false) ;
 _sizemenu->setItemEnabled(SIZE_ID_16384,false) ;
 _sizemenu->setItemEnabled(SIZE_ID_32768,false) ;
 _sizemenu->setItemEnabled(SIZE_ID_65536,false) ;

 QObject::connect(_sizemenu,SIGNAL(activated(int)),this,SLOT(slotSizeChanged(int))) ;

 _operationmenu = new QPopupMenu(this) ;
 _operationmenu->insertItem("calculate",this,SLOT(slotCalculate()),Qt::Key_F9) ;
 _operationmenu->insertItem("draw",this,SLOT(slotNeRienFaire()),Qt::Key_F10) ;
 //_operationmenu->setItemEnabled(10,false) ;


 _helpmenu = new QPopupMenu(this) ;
 _helpmenu->insertItem("&About fracat-0.0.0" , this , SLOT( slotAbout() ) ) ;
 _helpmenu->insertItem("About Qt" , this , SLOT( slotAboutQt() ) ) ;

 _menubar = new QMenuBar( this ) ;
 _menubar->insertItem("&File" , _filemenu ) ;
 _menubar->insertItem("&Type" , _typemenu ) ;
 _menubar->insertItem("&Size" , _sizemenu ) ;
 _menubar->insertItem("&Operation" , _operationmenu ) ;
 _menubar->insertSeparator() ;
 _menubar->insertItem("&Help" , _helpmenu ) ;
 _statusbar = new QStatusBar( this, "_statusbar" ) ;
 _labelType = new QLabel( this, "_labelType" ) ;
 _labelType->setText("Mandelbrot set") ;
 _statusbar->addWidget(_labelType,100) ;

 //_planche->setFocus() ;
 //_planche->grabKeyboard() ;
 _conteneur = new conteneur() ;
 _conteneur->setGeometry(0,0,514,514) ;

 QObject::connect( _conteneur,SIGNAL(signalRepartitionIntChanged(long*,long,long)),
 			this,SLOT(slotDrawRepartitionInt(long*,long,long))) ;
 QObject::connect( _conteneur,SIGNAL(signalFrameChanged(double,double,double,double)),
 			this,SLOT(slotFrameChanged( double,double,double,double))) ;
 QObject::connect( _dsRepartition,SIGNAL(valuesChanged(int,int)),this,
 			SLOT(slotDrawRepartitionZoomed(int,int)) ) ;
 QObject::connect( this,SIGNAL(signalDrawMatrixLong(long,long,long,int,bool)),_conteneur,
 			SLOT(slotDrawMatrixLong(long,long,long,int,bool)) ) ;
 QObject::connect( this,SIGNAL(signalCalculate(QString*)),_conteneur,
 			SLOT(slotCalculate(QString*)) ) ;
 QObject::connect( slider1,SIGNAL(valueChanged(int)),_conteneur,SLOT(slotDelayChanged(int)) ) ;
 QObject::connect( _dsPalette,SIGNAL(valuesChanged(int,int)),this,
 			SLOT(slotDrawMatrixForPalette(int,int)) ) ;

 QObject::connect( lineEdit5,SIGNAL(lostFocus()),this,SLOT(slotCoordinateChanged()) ) ;
 QObject::connect( lineEdit6,SIGNAL(lostFocus()),this,SLOT(slotCoordinateChanged()) ) ;
 QObject::connect( lineEdit7,SIGNAL(lostFocus()),this,SLOT(slotCoordinateChanged()) ) ;
 QObject::connect( lineEdit8,SIGNAL(lostFocus()),this,SLOT(slotCoordinateChanged()) ) ;

 // connections pour tenir compte des changements des paramtres autre que les coordonnes.
 QObject::connect( lineEdit_P1,SIGNAL(lostFocus()),this,SLOT(slotParamatersWithoutXYChanged()) ) ;


 show() ;
}

fenetrePrincipale :: ~fenetrePrincipale()
{
 delete _conteneur ;
 delete  _parameters ;
}

long fenetrePrincipale :: whatischeckedForColor()
{
 if (RadioButton2->isChecked()) return 0 ;
 	else
	{
	 if (RadioButton3->isChecked()) return 1 ;
			else return 2 ;
	}
}

void fenetrePrincipale :: slotDrawRepartitionInt(long* a,long m, long M)
{
 QString nb ;

 _repartition->drawRepartition(a) ;
 minii = m ;
 maxii = M ;
 lineEdit3->setText( nb.setNum(m) );
 lineEdit4->setText( nb.setNum(M) );
 _dsRepartition->setValues(0,SIZE_IMAGE_REPARTITION_X-1) ;
}

void fenetrePrincipale :: slotDrawRepartitionZoomed(int ml,int Ml)
{
 QString nb ;
 //double rml,rMl ;
 long iml,iMl,imr,iMr ;
 int mc,Mc ;


 if (isMatrixLong)
	{
	 iml = minii+(maxii-minii)*ml/SIZE_IMAGE_REPARTITION_X ;
	 iMl = minii+(maxii-minii)*Ml/SIZE_IMAGE_REPARTITION_X ;
	 _conteneur->getRepartitionLong(repartitionZoom,iml,iMl) ;
	 //for(i=0;i<256;i++) cout << "repartitionZoom[" << i << "] = " << repartitionZoom[i] << endl ;
	 //cout << endl ;
	 _repartition->drawRepartition(repartitionZoom) ;
	 lineEdit3->setText( nb.setNum(iml) );
	 lineEdit4->setText( nb.setNum(iMl) );
	 if (drawMatrixWithRepartition)
		{
		 iMl = iMl - iml ;
		 _dsPalette->values(&mc,&Mc) ;
		 imr = iml + mc * iMl / SIZE_IMAGE_REPARTITION_X ;
		 iMr = iml + Mc * iMl / SIZE_IMAGE_REPARTITION_X ;
		 signalDrawMatrixLong(imr,iMr,whatischeckedForColor(),slider1->value(),checkBox5->isChecked() ) ;
		}
	}
	else
	{
	//   A finir pour les double
	}

}

void fenetrePrincipale :: slotDrawMatrixForRepartition(int ml,int Ml)
{
 long iml,iMl,imr,iMr ;
 int mc,Mc ;

 if (isMatrixLong)
	{
	 iml = minii+(maxii-minii)*ml/SIZE_IMAGE_REPARTITION_X ;
	 iMl = minii+(maxii-minii)*Ml/SIZE_IMAGE_REPARTITION_X ;
	 iMl = iMl - iml ;
	 _dsPalette->values(&mc,&Mc) ;
	 imr = iml + mc * iMl / SIZE_IMAGE_REPARTITION_X ;
	 iMr = iml + Mc * iMl / SIZE_IMAGE_REPARTITION_X ;
	 if (drawMatrixWithRepartition)
		 emit signalDrawMatrixLong(imr,iMr,whatischeckedForColor(),slider1->value(),checkBox5->isChecked() ) ;
	}
	else
	{
	//   A finir pour les double
	}
}

void fenetrePrincipale :: slotDrawMatrixForPalette(int ml,int Ml)
{
 long iml,iMl,imr,iMr ;
 int v1,v2 ;

 if (isMatrixLong)
	{
	 _dsRepartition->values(&v1,&v2) ;
	 iml = minii+(maxii-minii)*v1/SIZE_IMAGE_REPARTITION_X ;
	 iMl = minii+(maxii-minii)*v2/SIZE_IMAGE_REPARTITION_X ;
	 iMl = iMl - iml ;
	 imr = iml + ml * iMl / SIZE_IMAGE_REPARTITION_X ;
	 iMr = iml + Ml * iMl / SIZE_IMAGE_REPARTITION_X ;
	 emit signalDrawMatrixLong(imr,iMr,whatischeckedForColor(),slider1->value(),checkBox5->isChecked() ) ;
	}
	else
	{
	//   A finir pour les double
	}
}

void fenetrePrincipale :: slotSaveImage()
{
 QString filename = QFileDialog::getSaveFileName(".","*.txt",this) ;
 if (!filename.isEmpty()) _conteneur->saveImage(filename) ;
 	else cout << " error of open file !" << filename << endl ;
}

void fenetrePrincipale :: slotSizeChanged(int a)
{
 long sizeLocal ;

 sizeLocal = 1 << (a+7) ;
 _conteneur->changeSizeMatrix(sizeLocal) ;
}

void fenetrePrincipale :: slotLoadPalette()
{
 QString filename = QFileDialog::getOpenFileName(".","*.txt",this) ;
 if (!filename.isEmpty()) _conteneur->loadPalette(filename) ;
 	else cout << " error of open file !" << filename << endl ;
}

void fenetrePrincipale :: slotLoadMatrix()
{
}

void fenetrePrincipale :: slotFrameChanged(double a,double b,double c,double d)
{
 QString nb ;

 lineEdit5->setText( nb.setNum( a,'g',16)  );
 lineEdit6->setText( nb.setNum( b,'g',16)  );
 lineEdit7->setText( nb.setNum( c,'g',16)  );
 lineEdit8->setText( nb.setNum( d,'g',16)  );
}

void  fenetrePrincipale :: fenetrePrincipale :: getCoordinate(QString* p)
{
 p[0] = lineEdit5->text() ; // x min
 p[1] = lineEdit6->text() ; // x max
 p[2] = lineEdit7->text() ; // y min
 p[3] = lineEdit8->text() ; // y max
}

void  fenetrePrincipale :: getParametersWithoutXY(QString* p)
{
 switch(whatSthat)
	{
	 case TYPE_ID_MANDELBROT :
		p[4] = lineEdit_P1->text() ; // nb iterations
		break ;
	}
}

void fenetrePrincipale :: slotCalculate()
{
 getCoordinate(_parameters) ;
 getParametersWithoutXY(_parameters) ;
 emit signalCalculate(_parameters) ;
}

void fenetrePrincipale :: slotCoordinateChanged()
{
 getCoordinate(_parameters) ;
 _conteneur->changeCoordinate(_parameters) ;
}

void  fenetrePrincipale :: slotParamatersWithoutXYChanged()
{
 getParametersWithoutXY(_parameters) ;
_conteneur->changeParametersWithoutXY(_parameters) ;
}

void fenetrePrincipale :: paintEvent( QPaintEvent* event )
{
 //cout << " +" << endl ;
 //bitBlt( tab , 9 , 3 , &_bufferRepartitionGlobal ) ;
}

void fenetrePrincipale :: resizeEvent( QResizeEvent* event)
{

}

void fenetrePrincipale :: slotAbout()
{

 QMessageBox::information( this , "A Propos de fracat-0.0.0",
 				  "Appplication fracat-0.0.0 febrary 03 2006\n"
				  "Copyright 2006 - Raphi :o)\n"
				  "raphael.pasquier@free.fr\n"
				  "Licence GPL v2") ;

}

void fenetrePrincipale :: slotAboutQt()
{
 QMessageBox::aboutQt( this , "A Propos de Qt" ) ;
}

void fenetrePrincipale :: slotPreferences()
{
 preferences* myp ;

 myp = new preferences() ;
 int ret = myp->exec() ;
 //if (ret == QDialog::Accepted) ;
 if (ret == QDialog::Accepted) drawMatrixWithRepartition = myp->drawWithRepartitionIsChecked() ;
 delete myp ;
}

void fenetrePrincipale :: slotNeRienFaire()
{
}

















