#ifndef CONSTANTS_H
#define CONSTANTS_H


#define SIZE_PLANCHE 512
#define EPSILON 1e-15
#define MASK_COLOR 255
#define SIZE_IMAGE_REPARTITION_X 256
#define SIZE_IMAGE_REPARTITION_Y 100

enum sizeID
{
 SIZE_ID_128,
 SIZE_ID_256,
 SIZE_ID_512,
 SIZE_ID_1024,
 SIZE_ID_2048,
 SIZE_ID_4096,
 SIZE_ID_8192,
 SIZE_ID_16384,
 SIZE_ID_32768,
 SIZE_ID_65536
} ;

#define SIZE_128 128
#define SIZE_256 256
#define SIZE_512 512
#define SIZE_1024 1024
#define SIZE_2048 2048
#define SIZE_4096 4096
#define SIZE_8192 8196
#define SIZE_16384 16384

enum typeID
{
 TYPE_ID_MANDELBROT,
 TYPE_ID_JULIA
} ;




#endif


